//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki
#include <iostream>
#include "naglowki.h"
//funkcja rippowania płyt cd / 148 linijek kodu
void rippowanie(kontenery_zmiennych_str zmienneTxtburn)
{
//-----------------------------------------------------------------------------------//
    int rip;
#ifndef __WIN32__ // <- jeśli znajdziesz czas na szukanie lame, oggenc, icedax na windowsa to usuń takie wpisy
    int liczba_pliku, liczba_pliku2; // zmienne przechowujące nr pliku wav
    bool czyDobrze;
    string numer_pliku, numer_pliku2; // to samo co liczba_pliku tyle że ta wartość jest już w string
    stringstream int2string, int2string2; // po to aby wyciągnąć wartość z liczba_pliku a potem przekazać do w/w zmiennej w string
//-----------------------------------------------------------------------------------//    
	string cdda2mp3dir2 = zmienneTxtburn.cdda2mp3dir;
    string cdda2oggdir2 = zmienneTxtburn.cdda2oggdir;
    string cdda2wavdir2 = zmienneTxtburn.cdda2wavdir;
    string wav2mp3dir2 = zmienneTxtburn.wav2mp3dir;
    string wav2oggdir2 = zmienneTxtburn.wav2oggdir;
//-----------------------------------------------------------------------------------//
    vector<string> cdda2mp3dir; cdda2mp3dir.push_back(zmienneTxtburn.cdda2mp3dir);
    vector<string> cdda2oggdir; cdda2oggdir.push_back(zmienneTxtburn.cdda2oggdir);
    vector<string> cdda2wavdir; cdda2wavdir.push_back(zmienneTxtburn.cdda2wavdir);
    vector<string> wav2mp3dir; wav2mp3dir.push_back(zmienneTxtburn.wav2mp3dir);
    vector<string> wav2oggdir; wav2oggdir.push_back(zmienneTxtburn.wav2oggdir);
    vector<string> nic; nic.push_back(zmienneTxtburn.nic);
    string DEVCDDA = zmienneTxtburn.DEVCDDA;
    string programname, programparams;
    string prog_extend = prog_ext();
#endif // <- i te też trzeba będzie usunąć
/*
// poniżej są zmienne których już nie używam ale w razie czego będę się na nich wzorować
//string apps = portable_apps();
    string cdda2wav = apps + "icedax" + prog_ext() + " -D " + DEVCDDA + " -s -x -B  " + cdda2wavdir + "";
    string cdda2mp3 = "MP_CODER=" + apps + "lame" + prog_ext() + "  " + apps + "cdda2mp3" + prog_ext() + " -D " + DEVCDDA + " -s -x -B  " + cdda2mp3dir + "";
    string cdda2ogg = "MP_CODER=" + apps + "oggenc" + prog_ext() + "  " + apps + "cdda2ogg" + prog_ext() + " -D " + DEVCDDA + " -s -x -B  " + cdda2oggdir + "";
    string wav2mp3 = apps + "lame" + prog_ext() + " -V2 --preset standard --nogap  " + cdda2wavdir + "*.wav  --nogapout  " + wav2mp3dir + "";
    string wav2ogg;
*/
//-----------------------------------------------------------------------------------//
#ifndef __WIN32__
    do
    {
#endif
        clrscr(); //menu do rippowania płyt AudioCD i konwersji plików audio
        cout << PL(file2lang("ripper_welcome"))
             << PL(file2lang("global_menu_info"))
             << PL(file2lang("ripper_menu_list"));
        //<< "* - numeracja ścieżek wav\n";
#ifndef __WIN32__
        cin >> rip;
        czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, rip);
        switch (rip)
        {
        case 1:
        {
            clrscr();
            cout << PL(file2lang("ripper_menu_list_info")) << PL(file2lang("ripper_menu_list1_info"));
//-----------------------------------------------------------------------------------//
            runprog("cdda2ogg" + prog_extend + "", " -D " + DEVCDDA + " -s -x -B  ", cdda2oggdir, "", nic,"");
//-----------------------------------------------------------------------------------//
            cout << PL(file2lang("after_convert_info")) << PL(file2lang("ripper_menu_list1_info"))
                 << PL(file2lang("after_convert_info2")) << cdda2oggdir2 << " \n" << endl;
            cout << PL(file2lang("press_enter3"));
            getchar();
            break;
        }
        case 2:
        {
            clrscr();
            cout << PL(file2lang("ripper_menu_list_info")) << PL(file2lang("ripper_menu_list2_info"));
//-----------------------------------------------------------------------------------//
            runprog("icedax" + prog_ext(), " -D " + DEVCDDA + " -s -x -B  ", cdda2wavdir, "", nic,"");
//-----------------------------------------------------------------------------------//
            cout << PL(file2lang("after_convert_info")) << PL(file2lang("ripper_menu_list2_info"))
                 << PL(file2lang("after_convert_info2")) << cdda2wavdir2 << " \n" << endl;
            cout << PL(file2lang("press_enter3"));
            getchar();
            break;
        }
        case 3:
        {
            clrscr();
            cout << PL(file2lang("ripper_menu_list_info")) << PL(file2lang("ripper_menu_list3_info"));
//-----------------------------------------------------------------------------------//
            programname = "cdda2mp3" + prog_ext();
            runprog(programname, " -D " + DEVCDDA + " -s -x -B  ", cdda2mp3dir,"",nic,"");
//-----------------------------------------------------------------------------------//
            cout << PL(file2lang("after_convert_info")) << PL(file2lang("ripper_menu_list3_info"))
                 << PL(file2lang("after_convert_info2")) << cdda2mp3dir2 << " \n" << endl;
            cout << PL(file2lang("press_enter3"));
            getchar();
            break;
        }
        case 4:
        {
            clrscr();
            cout << PL(file2lang("ripper_menu_list_info")) << PL(file2lang("ripper_menu_list4_info"));
//-----------------------------------------------------------------------------------//
            liczba_pliku = 1;
            liczba_pliku2 = 0;
//-----------------------------------------------------------------------------------//
            do
            {
                //-----------------------------------------------------------------------------------//
                //-----------------------------------------------------------------------------------//
                int2string.clear(); // podwójne czyszczenie zmiennej w
                int2string.str(""); // stringstream
                //-----------------------------------------------------------------------------------//
                int2string2.clear(); // to samo co wyżej
                int2string2.str(""); // i wyżej
                //-----------------------------------------------------------------------------------//
                //-----------------------------------------------------------------------------------//
                numer_pliku.clear(); // czyszczenie zmiennej w string
                numer_pliku2.clear(); // i wyżej
                //-----------------------------------------------------------------------------------//
                //-----------------------------------------------------------------------------------//
                int2string << liczba_pliku; // przekazanie wartość zmiennej typu int do zmiennej typu stringstream
                int2string2 << liczba_pliku2; // to samo co wyżej
                //-----------------------------------------------------------------------------------//
                numer_pliku = int2string.str(); // a tutaj z stringstream do string
                numer_pliku2 = int2string2.str(); // to samo co wyżej
                //-----------------------------------------------------------------------------------//
                //-----------------------------------------------------------------------------------//
                if (liczba_pliku < 10)
                {
//-----------------------------------------------------------------------------------//
                    programname = "oggenc" + prog_ext();
                    runprog(programname, " -q 5  ", cdda2wavdir, "*" + numer_pliku2 + "" + numer_pliku + "*.wav -n  ", wav2oggdir, numer_pliku + ".ogg");
//-----------------------------------------------------------------------------------//
                }
                else if (liczba_pliku > 9)
                {
//-----------------------------------------------------------------------------------//
                    programname = "oggenc" + prog_ext();
                    runprog(programname, " -q 5  ",cdda2wavdir, "*" + numer_pliku + "*.wav -n  " ,wav2oggdir ,numer_pliku + ".ogg");
//-----------------------------------------------------------------------------------//
                }
                liczba_pliku++; //ile2++;
            }
            while (!(liczba_pliku > 50));
            cout << PL(file2lang("after_convert_info")) << PL(file2lang("ripper_menu_list4_info"))
                 << PL(file2lang("after_convert_info2")) << wav2oggdir2 << " \n" << endl;
            cout << PL(file2lang("press_enter3"));
            getchar();
            break;
        }
        case 5:
        {
            clrscr();
            cout << PL(file2lang("ripper_menu_list_info")) << PL(file2lang("ripper_menu_list5_info"));
//-----------------------------------------------------------------------------------//
            runprog("lame" + prog_ext(), " -V2 --preset standard --nogap  ",cdda2wavdir,"*.wav  --nogapout  ",wav2mp3dir,"");
//-----------------------------------------------------------------------------------//
            cout << PL(file2lang("after_convert_info")) << PL(file2lang("ripper_menu_list5_info"))
                 << PL(file2lang("after_convert_info2")) << wav2mp3dir2 << " \n" << endl;
            cout << PL(file2lang("press_enter3"));
            getchar();
            break;
        }
        case 9:
        {
            clrscr();
            break;
        }
        case 0:
        {
            clrscr();
            cout << PL(file2lang("exit_info"));
            exit(0);
            break;
        }
        default:
        {
            clrscr();
            cout << PL(file2lang("menu_not_found_info"));
            break;
        }
        }
    }
    while (!(rip == 9));
#endif
}
