#include <iostream>
#include "naglowki.h"
//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki


void ustaw_programu(int &iMAXSPEED, int &iBUFFERSIZE, kontenery_zmiennych_str &zmienneTxtburn)
{
    string txtburn_conf = txtburn_cfg_file();
    stringstream int2string, int2string2; stringstream string2int, string2int2;
//---------------------------------------------------------------//
    string devname = zmienneTxtburn.devname;
    string devcdda = zmienneTxtburn.devcdda;
    string inDIRECTORY = zmienneTxtburn.inDIRECTORY;
    string outDIRECTORY = zmienneTxtburn.outDIRECTORY;
    string VOLNAME = zmienneTxtburn.VOLNAME;
    string ISONAME = zmienneTxtburn.ISONAME;
    string cdda2mp3dir = zmienneTxtburn.cdda2mp3dir;
    string cdda2oggdir = zmienneTxtburn.cdda2oggdir;
    string cdda2wavdir = zmienneTxtburn.cdda2wavdir;
    string wav2mp3dir = zmienneTxtburn.wav2mp3dir;
    string wav2oggdir = zmienneTxtburn.wav2oggdir;
    string DEVICE = zmienneTxtburn.DEVICE;
    string DEVCDDA = zmienneTxtburn.DEVCDDA;
    string DIRIISO = zmienneTxtburn.DIRIISO;
    string MAXSPEED = zmienneTxtburn.MAXSPEED;
    string BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
//---------------------------------------------------------------//

    int ustaw;
    do
    {
        //clrscr(); //menu edycji zmiennych w programie
        cout << PL(file2lang("settings_welcome"))
             << PL(file2lang("settings_menu_info"))
             << PL(file2lang("settings_menu_list1"));
#ifndef __WIN32__             
		cout << PL(file2lang("settings_menu_list2"));
#endif
        cout << PL(file2lang("settings_menu_list"));
        cin >> ustaw;
        bool czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, ustaw);
        switch (ustaw)
        {
        case 1:
        {
            clrscr();
        ust_wypalanie(iMAXSPEED, iBUFFERSIZE, zmienneTxtburn);
            break;
        }
#ifndef __WIN32__
        case 2:
        {
            clrscr();
		ust_ripp(iMAXSPEED, iBUFFERSIZE, zmienneTxtburn);
            break;
        }
#endif
/*		case 5: // jest to niedokończona funkcja programu do zmiany domyślnego folderu,
		{// zmiana domyślnego katalogu // taki mój chwilowy wymysł ; np. taki w którym jest przechowywany plik konfiguracyjny, itp. 
            clrscr(); // jeśli ktoś by chciał to może dokończyć moją taką chwilową myśl
		cout << "Widze że chciałbyś koniecznie zmienić domyślny folder.\n"
			 << "Teraz prosze abyś wpisał "
		zmienneTxtburn.default_folder = txtburn_default_folder();
		string default_folder = zmienneTxtburn.default_folder;

		}*/  
		case 4:
		{
		clrscr();
		lang = set_lang();
		}
		case 6:
        { // przywrócenie domyślnych zmiennych
            clrscr();
            return2default(zmienneTxtburn);
//---------------------------------------------------------------//
            MAXSPEED = zmienneTxtburn.MAXSPEED;
            BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
            stringstream string2int(MAXSPEED);
            stringstream string2int2(BUFFERSIZE);
            string2int >> iMAXSPEED;
            string2int2 >> iBUFFERSIZE;
//---------------------------------------------------------------//
            break;
        }
        case 7:
        {
            // wczytanie zmiennych z pliku
            clrscr();
            file2string(zmienneTxtburn);
//---------------------------------------------------------------//
            MAXSPEED = zmienneTxtburn.MAXSPEED;
            BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
            stringstream string2int(MAXSPEED);
            stringstream string2int2(BUFFERSIZE);
            string2int >> iMAXSPEED;
            string2int2 >> iBUFFERSIZE;
//---------------------------------------------------------------//
            break;
        }
        case 8:
        {
            // zapis zmiennych do pliku
            clrscr();
//---------------------------------------------------------------//
            int2string.clear();
            int2string.str("");
            int2string2.clear();
            int2string2.str("");
            zmienneTxtburn.MAXSPEED.clear();
            zmienneTxtburn.BUFFERSIZE.clear();
            int2string << iMAXSPEED;
            int2string2 << iBUFFERSIZE;
            zmienneTxtburn.MAXSPEED = int2string.str();
            zmienneTxtburn.BUFFERSIZE = int2string2.str();
//---------------------------------------------------------------//
            save2file(zmienneTxtburn);
            break;
        }
        case 9:
		{
        break;
		}
        case 0:
        {
            clrscr();
            cout << PL(file2lang("exit_info"));
            //return 0;
            exit(0);
            break;
        }
        default:
        {
            clrscr();
            cout << PL(file2lang("menu_not_found_info"));
            break;
        }
        }
    }
    while (!(ustaw == 9));
}

void ust_wypalanie(int &iMAXSPEED, int &iBUFFERSIZE, kontenery_zmiennych_str &zmienneTxtburn)
{//TODO *dokończyć tą funkcje*
//---------------------------------------------------------------//
	stringstream int2string, int2string2; stringstream string2int, string2int2;
	string devname = zmienneTxtburn.devname;
    string DIRIISO = zmienneTxtburn.DIRIISO;
    string MAXSPEED = zmienneTxtburn.MAXSPEED;
    string BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
    string inDIRECTORY = zmienneTxtburn.inDIRECTORY;
    string outDIRECTORY = zmienneTxtburn.outDIRECTORY;
    string VOLNAME = zmienneTxtburn.VOLNAME;
    string ISONAME = zmienneTxtburn.ISONAME;
	string DEVICE = zmienneTxtburn.DEVICE;
#ifdef __WIN32__
	devname = DEVICE;
#endif
//---------------------------------------------------------------//    
int wyp_ust;
char pytanie;
do
{        
		cout << PL(file2lang("burner_settings_menu_info"))
             << PL(file2lang("burner_settings_menu_info2"));
        cout << PL(file2lang("burner_settings_menu_list1")) << weDIRECTORY << " / " << inDIRECTORY << ")\n"
             << PL(file2lang("burner_settings_menu_list2")) << wyDIRECTORY << " / " << outDIRECTORY << ")\n"
             << PL(file2lang("burner_settings_menu_list3")) << ISONAME << ")\n"
             << PL(file2lang("burner_settings_menu_list4")) << devdev << devdvd << " / " << devdev << devname << ")\n"
             << PL(file2lang("burner_settings_menu_list5")) << VOLNAME << ")\n"
             << PL(file2lang("burner_settings_menu_list6")) << iMAXSPEED << ")\n\n";
		cout << PL(file2lang("burner_settings_menu_list9"));
		cin >> wyp_ust;
        bool czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, wyp_ust);
        switch (wyp_ust)
        {
        case 1:
        {
            clrscr();
            cout << PL(file2lang("burner_settings_menu_list_info")) << PL(file2lang("burner_settings_menu_list1_info"))
                 << PL(file2lang("burner_settings_menu_list7_info"));
            getline(cin, inDIRECTORY);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 2:
        {
            clrscr();
            cout << PL(file2lang("burner_settings_menu_list_info")) << PL(file2lang("burner_settings_menu_list2_info"))
                 << PL(file2lang("burner_settings_menu_list7_info"));
            getline(cin, outDIRECTORY);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 3:
        {
            clrscr();
            cout << PL(file2lang("burner_settings_menu_list_info2")) << PL(file2lang("burner_settings_menu_list3_info"))
                 << PL(file2lang("burner_settings_menu_list8_info"));
            getline(cin, ISONAME);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 4:
        {
            clrscr();
            cout << "\n";
            devname = konfig_naped_dvd(wyp_ust);
            cout << "\n";
            break;
        }
        case 5:
        {
            clrscr();
            cout << PL(file2lang("burner_settings_menu_list_info2")) << PL(file2lang("burner_settings_menu_list4_info"))
                 << PL(file2lang("burner_settings_menu_list8_info"));
            getline(cin, VOLNAME);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 6:
        {
            clrscr();
            cout << "\n";
            iMAXSPEED = konfig_iMaxspeed(iMAXSPEED);
            cout << "\n";
            break;
        }
        case 9:
        {
            //clrscr();
            cout << PL(file2lang("cfg_update_info"));
            cin >> pytanie;
            cin.clear();
            cin.ignore(1000, '\n');
            cout << "\n\n";
            if ((pytanie == 'T')||(pytanie == 't'))
            {
//---------------------------------------------------------------//
                //clrscr();
                cout << PL(file2lang("cfg_update_info1"));
//zapis konfiguracji ogólnej
                zmienneTxtburn.inDIRECTORY = inDIRECTORY;
                zmienneTxtburn.outDIRECTORY = outDIRECTORY;
                zmienneTxtburn.devname = devname;
                zmienneTxtburn.DEVICE = devdev + devname + "";
                cout << "OK \n";
                cout << PL(file2lang("cfg_update_info2"));
//zapis konfiguracji wypalania płyt CD/DVD
                zmienneTxtburn.VOLNAME = VOLNAME;
                zmienneTxtburn.ISONAME = ISONAME;
                zmienneTxtburn.DIRIISO = outDIRECTORY + slashslash + ISONAME + "";
                int2string.clear();
                int2string.str("");
                int2string2.clear();
                int2string2.str("");
                zmienneTxtburn.MAXSPEED.clear();
                zmienneTxtburn.BUFFERSIZE.clear();
                int2string << iMAXSPEED;
                int2string2 << iBUFFERSIZE;
                zmienneTxtburn.MAXSPEED = int2string.str();
                zmienneTxtburn.BUFFERSIZE = int2string2.str();
                cout << "OK \n";
                cout << PL(file2lang("cfg_update_info4"));
//tworzenie katalogów z uprzednio wyedytowanych zmiennych
                string makedir = inDIRECTORY + " " + outDIRECTORY + "";
                string null = " ";
                vector <string> Makedir; Makedir.push_back(makedir);
                vector <string> nic; nic.push_back(null);
                runprog(MKdir, "",Makedir, "", nic, "");
                makedir.clear();
                cout << "OK \n";
                cout << PL(file2lang("cfg_update_info_success"));
                getchar();
            }
            else;
            clrscr();
            break;
        }
				
		default:
        {
            clrscr();
            cout << PL(file2lang("menu_not_found_info"));
            break;
        }
        }
    }
    while (!(wyp_ust == 9));
}

void ust_ripp(int &iMAXSPEED, int &iBUFFERSIZE, kontenery_zmiennych_str &zmienneTxtburn)
{//TODO *dokończyć tą funkcje*
//---------------------------------------------------------------//
    stringstream int2string, int2string2; stringstream string2int, string2int2;
	string cdda2mp3dir = zmienneTxtburn.cdda2mp3dir;
    string cdda2oggdir = zmienneTxtburn.cdda2oggdir;
    string cdda2wavdir = zmienneTxtburn.cdda2wavdir;
    string wav2mp3dir = zmienneTxtburn.wav2mp3dir;
    string wav2oggdir = zmienneTxtburn.wav2oggdir;    
	string devcdda = zmienneTxtburn.devcdda;
    string DEVCDDA = zmienneTxtburn.DEVCDDA;
//---------------------------------------------------------------// 
int rip_ust;
char pytanie;
do
{ 
		cout << PL(file2lang("ripper_settings_menu_info"))
             << PL(file2lang("ripper_settings_menu_info2"));
        cout << PL(file2lang("ripper_settings_menu_list1")) << Cdda2wavdir <<" / "<< cdda2wavdir << ")\n"
             << PL(file2lang("ripper_settings_menu_list2")) << Cdda2oggdir <<" / "<< cdda2oggdir << ")\n"
             << PL(file2lang("ripper_settings_menu_list3")) << Cdda2mp3dir <<" / "<< cdda2mp3dir << ")\n"
             << PL(file2lang("ripper_settings_menu_list4")) << Wav2oggdir <<" / "<< wav2oggdir << ")\n"
             << PL(file2lang("ripper_settings_menu_list5")) << Wav2mp3dir <<" / "<< wav2mp3dir << ")\n"
             << PL(file2lang("ripper_settings_menu_list6")) << devdev<<devaudiocd << " / " << devdev<<devcdda << ")\n\n";
		cout << PL(file2lang("ripper_settings_menu_list9"));
		cin >> rip_ust;
        bool czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, rip_ust);
        switch (rip_ust)
        {
        case 10:
        {
            clrscr();
            cout << PL(file2lang("ripper_settings_menu_list_info")) << PL(file2lang("ripper_settings_menu_list1_info"))
                 << PL(file2lang("ripper_settings_menu_list7_info"));
            getline(cin, cdda2wavdir);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 11:
        {
            clrscr();
            cout << PL(file2lang("ripper_settings_menu_list_info")) << PL(file2lang("ripper_settings_menu_list2_info"))
                 << PL(file2lang("ripper_settings_menu_list7_info"));
            getline(cin, cdda2oggdir);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 12:
        {
            clrscr();
            cout << PL(file2lang("ripper_settings_menu_list_info")) << PL(file2lang("ripper_settings_menu_list3_info"))
                 << PL(file2lang("ripper_settings_menu_list7_info"));
            getline(cin, cdda2mp3dir);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 13:
        {
            clrscr();
            cout << PL(file2lang("ripper_settings_menu_list_info")) << PL(file2lang("ripper_settings_menu_list4_info"))
                 << PL(file2lang("ripper_settings_menu_list7_info"));
            getline(cin, wav2oggdir);
            cin.clear();
            cin.ignore(1000, '\n');

            break;
        }
        case 14:
        {
            clrscr();
            cout << PL(file2lang("ripper_settings_menu_list_info")) << PL(file2lang("ripper_settings_menu_list5_info"))
                 << PL(file2lang("ripper_settings_menu_list7_info"));
            getline(cin, wav2mp3dir);
            cin.clear();
            cin.ignore(1000, '\n');

            break;
        }
        case 15:
        {
            clrscr();
            cout << "\n";
            devcdda = konfig_naped_dvd(rip_ust);
            cout << "\n";
            break;
        }
        case 9:
        {
            //clrscr();
            cout << PL(file2lang("cfg_update_info"));
            cin >> pytanie;
            cin.clear();
            cin.ignore(1000, '\n');
            cout << "\n\n";
            if ((pytanie == 'T')||(pytanie == 't'))
            {
//---------------------------------------------------------------//
                //clrscr();
                cout << PL(file2lang("cfg_update_info3"));
//zapis konfiguracji rippowania płyt
                zmienneTxtburn.devcdda = devcdda;
                zmienneTxtburn.DEVCDDA = devdev + devcdda + "";
                zmienneTxtburn.cdda2mp3dir = cdda2mp3dir;
                zmienneTxtburn.cdda2oggdir = cdda2oggdir;
                zmienneTxtburn.cdda2wavdir = cdda2wavdir;
                zmienneTxtburn.wav2mp3dir = wav2mp3dir;
                zmienneTxtburn.wav2oggdir = wav2oggdir;
                cout << "OK \n";
                cout << PL(file2lang("cfg_update_info4"));
//tworzenie katalogów z uprzednio wyedytowanych zmiennych
                string makedir = cdda2mp3dir + " " + cdda2oggdir + " " + cdda2wavdir + " " + wav2mp3dir + " " + wav2oggdir + "";
                string null = " ";
                vector <string> Makedir; Makedir.push_back(makedir);
                vector <string> nic; nic.push_back(null);
                runprog(MKdir, "",Makedir, "", nic, "");
                makedir.clear();
                cout << "OK \n";
                cout << PL(file2lang("cfg_update_info_success"));
                getchar();
            }
            else;
            clrscr();
            break;
        }
        default:
        {
            clrscr();
            cout << PL(file2lang("menu_not_found_info"));
            break;
        }
        }
    }
    while (!(rip_ust == 9));
}
